const pako = require('pako');
const Base64 = require('./Base64');

class Gzip {
  encode(string) {
    if (typeof string !== 'string') {
      return null;
    }
    
    const uint8Array = pako.deflate(string, { to: "string" });
    const uint8String = this.uint8ToString(uint8Array);
    const encodedString = Base64.encode(uint8String, 'binary');
    
    return encodedString;
  };

  decode(string) {
    if (typeof string !== 'string') {
      return null;
    }

    if (!Base64.isValid(string)) {
      return string;
    }

    const uint8String = Base64.decode(string.trim(), false, 'binary');
    const uint8Array = uint8String.split('').map(function(x){return x.charCodeAt(0);});
    const decodedString = pako.inflate(uint8Array, { to: "string" });

    return decodedString;
  };

  uint8ToString(uint8Value) {
    const bufferSize = 0x8000;
    const charCode = [];
    
    for (let i = 0; i < uint8Value.length; i += bufferSize) {
      charCode.push(String.fromCharCode.apply(null, uint8Value.subarray(i, i + bufferSize)));
    }

    return charCode.join("");
  }
}

module.exports = new Gzip();
