const oracledb = require('oracledb');

class DBParameter {

  static create(param) {
    const newParam = {
      dir: DBParameter.handleDirectionType(param.dir),
    };
    if(param.maxSize) {
      newParam.maxSize = param.maxSize;
    }
    if(param.type) {
      newParam.type = DBParameter.handleParamType(param.type)
    }
    if('value' in param) {
      newParam.val = param.value;
    }
    return newParam;
  }

  static handleDirectionType(direction) {
    const DIRECTIONS = {
      IN: oracledb.BIND_IN,
      OUT: oracledb.BIND_OUT,
      INOUT: oracledb.BIND_INOUT
    };
    return DIRECTIONS[direction] || DIRECTIONS.IN;
  }

  static handleParamType(type) {
    const TYPES = {
      STRING: oracledb.STRING,
      NUMBER: oracledb.NUMBER,
    };
    return type in TYPES ? TYPES[type] : oracledb[type] || null;
  }
}

module.exports = DBParameter;