const DB = require('../database/DB');

class UpdaterServicoFili {
  UPDATE = `
    UPDATE
      UPDATERSERVICOFILI
    SET
      MONITORAMENTO = :P_MONITORAMENTO
    WHERE
      CDFILIAL = :P_CDFILIAL
  `;
  GET_SERVICE_MONITORING = `
    SELECT
      CDFILIAL,
      MONITORAMENTO
    FROM
      UPDATERSERVICOFILI
    WHERE
      MONITORAMENTO IS NOT NULL
  `;
  GET_SERVICE_MONITORING_BY_UNIT = `
    SELECT
      CDFILIAL,
      MONITORAMENTO
    FROM
      UPDATERSERVICOFILI
    WHERE
      CDFILIAL = :P_CDFILIAL
  `;

  GET_SERVICE_MONITORING_WITH_UNIT = `
    SELECT
      U.CDFILIAL,
      F.CDFILIAL || ' - ' || F.NMFILIAL AS FILIAL
    FROM
      UPDATERSERVICOFILI U
      LEFT JOIN FILIAL F ON (F.CDFILIAL = U.CDFILIAL)
    WHERE
      MONITORAMENTO IS NOT NULL
  `

  update(params, executionParams = {}) {
    return DB.execute(this.UPDATE, params, executionParams);
  }

  getServiceMonitoring() {
    return DB.fetch(this.GET_SERVICE_MONITORING);
  }

  getServiceMonitoringWithUnit() {
    return DB.fetch(this.GET_SERVICE_MONITORING_WITH_UNIT);
  }

  getServiceMonitoringByUnit(params) {
    return DB.fetch(this.GET_SERVICE_MONITORING_BY_UNIT, params);
  }

}

module.exports = new UpdaterServicoFili();