const DB = require('../database/DB');

class updaterModelCasher {
    constructor(){
        this.GET_PRODUCTS_VERSION = `
            SELECT
                PF.ID AS PRODFILIID,
                F.CDFILIAL || ' - ' || F.NMFILIAL AS FILIAL,
                F.CDFILIAL,
                F.NMFILIAL,
                CX.CDCAIXA,
                CX.NMCAIXA,
                CX.CDCAIXA || ' - ' || CX.NMCAIXA AS CAIXA,
                P.ID AS PRODUCTID,
                P.NMPRODUCT,
                EV.CDEVENTO,
                CASE
                WHEN PF.NRVERSAOATUAL IS NULL THEN
                    'INSTALACAO_PENDENTE'
                ELSE
                    'INSTALADO'
                END AS IDSTEVENTO,
                DECODE(PF.NRVERSAOATUAL, NULL, '-', PF.NRVERSAOATUAL) AS NRVERSAOATUAL,
                TO_CHAR(PF.DTULTATU, 'DD/MM/YYYY HH24:MI') AS DTULTATU,
                OP.CDOPERADOR,
                OP.NMOPERADOR
            FROM
                UPDATERPRODFILICX PF
                INNER JOIN UPDATERPRODUTOS P
                    ON (PF.UPDATERPRODID = P.ID)
                INNER JOIN FILIAL F
                    ON (PF.CDFILIAL = F.CDFILIAL)
                INNER JOIN CAIXA CX
                    ON PF.CDFILIAL = CX.CDFILIAL
                    AND PF.CDCAIXA = CX.CDCAIXA
                LEFT JOIN (
                    SELECT
                        CDFILIAL,
                        CDCAIXA,
                        CDPRODFILIID,
                        CDPRODUCTID,
                        MAX(CDEVENTO) AS CDEVENTO
                    FROM
                        UPDATEREVENTOSCX
                    WHERE
                        IDSTEVENTO = 'FINALIZADO'
                    GROUP BY
                        CDFILIAL,
                        CDCAIXA,
                        CDPRODUCTID,
                        CDPRODFILIID
                ) EV
                    ON (
                        EV.CDPRODUCTID = P.ID AND
                        EV.CDPRODFILIID = PF.ID AND
                        EV.CDFILIAL = PF.CDFILIAL AND
                        EV.CDCAIXA  = PF.CDCAIXA
                    )
                LEFT JOIN UPDATERHISTORICOCX HIST
                    ON  HIST.CDEVENTO = EV.CDEVENTO
                    AND HIST.IDSTEVENTO = 'FINALIZADO'
                LEFT JOIN OPERADOR OP
                    ON OP.CDOPERADOR = HIST.CDOPERADOR
            WHERE
                PF.CDFILIAL = :P_CDFILIAL AND
                PF.CDCAIXA  = :P_CDCAIXA
            ORDER BY
                P.ID ASC
        `;

        this.GET_CASHER_WITHOUT_PRODUCTS = `
            SELECT
              UP.ID AS UPDATERPRODID,
              CX.CDFILIAL,
              CX.CDCAIXA
            FROM UPDATERPRODUTOS UP
            CROSS JOIN CAIXA CX
            WHERE
                  UP.ID       = :UPDATERPRODID
              AND CX.CDFILIAL = :CDFILIAL
              AND CX.CDCAIXA NOT IN (
                    SELECT
                      CDCAIXA
                    FROM UPDATERPRODFILICX
                    WHERE
                          CDFILIAL = CX.CDFILIAL
                      AND CDCAIXA = CX.CDCAIXA
                      AND UPDATERPRODID = :UPDATERPRODID
              )
        `;

    }

    async getProductsVersion(params) {
        return DB.fetch(this.GET_PRODUCTS_VERSION, params);
    }

    async getCasherWithoutProduct(params) {
        return DB.fetch(this.GET_CASHER_WITHOUT_PRODUCTS, params);
    }

}

module.exports = new updaterModelCasher();