const UpdaterControllerEx = require('../controller/UpdaterControllerEx');

function updaterRoute(router){
  router.post('/updater/checkVersion', UpdaterControllerEx.checkInstalledVersion)
  router.post('/updater/installVersion', UpdaterControllerEx.installVersion)
  router.post('/updater/multiInstallVersion', UpdaterControllerEx.multiInstallVersion)
  router.post('/updater/removeVersion', UpdaterControllerEx.removeVersion)
  router.post('/updater/installVersionInProgress', UpdaterControllerEx.installVersionInProgress)
  router.post('/updater/removeVersionInProgress', UpdaterControllerEx.removeVersionInProgress)
  router.post('/updater/finishUpdater', UpdaterControllerEx.finishUpdater)
  router.post('/updater/cancelUpdater', UpdaterControllerEx.cancelUpdater)
  router.post('/updater/cancelUnitEvents', UpdaterControllerEx.cancelUnitEvents)
  router.post('/updater/getPendingEventsByUnit', UpdaterControllerEx.getPendingEventsByUnit)
  router.post('/updater/getAvailablePackages', UpdaterControllerEx.getAvailablePackages)
  router.post('/updater/saveConfigDb', UpdaterControllerEx.saveConfigDb)
  router.post('/updater/updateConfigDb', UpdaterControllerEx.updateConfigDb)
  router.post('/updater/loadConfigDb', UpdaterControllerEx.loadConfigDb)
  router.post('/updater/getConfigIniByUnit', UpdaterControllerEx.getConfigIniByUnit)
  router.post('/updater/saveConfigIniByUnit', UpdaterControllerEx.saveConfigIniByUnit)
  router.post('/updater/getConfigHistoryByUnit', UpdaterControllerEx.getConfigHistoryByUnit)
  router.post('/updater/getProdConfig', UpdaterControllerEx.getProdConfig)
  router.post('/updater/saveProdConfig', UpdaterControllerEx.saveProdConfig)
  router.post('/updater/installNewVersion', UpdaterControllerEx.installNewVersion)
  router.post('/updater/removeEventsByUnit', UpdaterControllerEx.removeEventsByUnitAndProduct)
  router.post('/updater/updatePackageURL', UpdaterControllerEx.updatePackageURL)
  router.post('/updater/uploadLog', UpdaterControllerEx.uploadLog)
  router.post('/updater/verifyInstalledProducts', UpdaterControllerEx.verifyInstalledProducts)
  router.get('/updater/getLogFile', UpdaterControllerEx.getLogFile)
  router.post('/updater/verifyIntegrity', UpdaterControllerEx.verifyIntegrity)
}

module.exports = updaterRoute;